proc tclInit {} {
    global tcl_library tcl_version auto_index auto_path tcl_platform
    set tcl_library {}
    set ::wrap::library {}

# required packages: Tcl and Wrap
    ::wrap::source lib/tcl$tcl_version/init.tcl
    ::wrap::source lib/wrap${::wrap::version}/wrap.tcl
    ::wrap::index lib/wrap${::wrap::version}/tclIndex
    ::wrap::index lib/tcl$tcl_version/tclIndex
    package ifneeded Wrap ${::wrap::version} [list load {} Wrap]
    proc wrapInit {} {
	global tcl_version ::wrap::library ::wrap::version auto_index auto_path tcl_platform
	::wrap::source lib/wrap${::wrap::version}/wrap.tcl
	::wrap::index lib/wrap${::wrap::version}/tclIndex
    }

# optional packages: Http (1.0/2.1), Opt, Msgcat, registry.
    catch [list ::wrap::index lib/tcl$tcl_version/http1.0/pkgIndex.tcl]
    catch [list ::wrap::index lib/tcl$tcl_version/http2.1/pkgIndex.tcl]
    package ifneeded opt 0.4 "::wrap::index lib/tcl$tcl_version/opt0.4/optparse.tcl"
    package ifneeded msgcat 1.0 "::wrap::index lib/tcl$tcl_version/msgcat1.0/msgcat.tcl"

    if {![string compare $tcl_platform(platform) windows]} {
	catch {::wrap::index lib/tcl$tcl_version/dde1.1/pkgIndex.tcl}
	catch {::wrap::index lib/tcl$tcl_version/reg1.0/pkgIndex.tcl}
    }
    catch {::wrap::index lib/memchan2.1/pkgIndex.tcl}

# Tk
    proc tkInit {} {
	global tcl_version tk_library tk_version auto_index auto_path tcl_platform
	set tk_library {}
	set dir lib/tk$tk_version
	::wrap::source $dir/tk.tcl
	::wrap::source $dir/button.tcl
	::wrap::source $dir/entry.tcl
	::wrap::source $dir/listbox.tcl
	::wrap::source $dir/menu.tcl
	::wrap::source $dir/scale.tcl
	::wrap::source $dir/scrlbar.tcl
	::wrap::source $dir/text.tcl
	::wrap::index $dir/tclIndex
    }

# Tk-related optional packages: Img
    catch {::wrap::index lib/img1.2/pkgIndex.tcl}
}
